/***************************************************************************
                          kwifimanager_kcmodule.h  -  description
                             -------------------
    begin                : Die Okt  2 19:41:16 CEST 2001
    copyright            : (C) 2001 by Stefan Winter
    email                : mail@stefan-winter.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KWIFIMANAGER_KCMODULE_H_
#define KWIFIMANAGER_KCMODULE_H_

#include <kcmodule.h>
class QTabWidget;
class KAboutData;

class KWifimanager_ConfigWidget;
class KWifimanager_ConfigWidget2;

class KWifimanager_KCModule;

extern "C"
{

  void *init_libkcm_kwifimanager_kcmodule (QWidget * parent,
					   const char *name);

}

class KWifimanager_KCModule:public KCModule
{
    Q_OBJECT
public:
  KWifimanager_KCModule (QWidget * parent = 0L , const char *name = 0L,
			 const QStringList unnuetz = QStringList ());
    virtual ~ KWifimanager_KCModule ();
  static void init ();
  static void changeConfig (int x, QString interface);
  void load ();
  void defaults ();
  int buttons ();
  QString quickHelp () const;
  const KAboutData *aboutData ()
  {
    return myAboutData;
  };


public slots:
    void configChanged ();
    void slotSave ();
    void slotCallInit ();
    void slotChangeConfig (int config, QString interface);

private:
  KAboutData * myAboutData;
  KWifimanager_ConfigWidget *config1;
  KWifimanager_ConfigWidget *config2;
  KWifimanager_ConfigWidget *config3;
  KWifimanager_ConfigWidget *config4;
  KWifimanager_ConfigWidget2 *config_gen;
  QTabWidget *configwindow;
};

#endif
